<?php

class Weather
{

	private $YaUrl;
	private $YaCity;
	private $CacheTime;
	private $CachePath;

	public function __construct($w_cfg)
	{
		$this->YaUrl = $w_cfg['YaUrl'];
		$this->YaCity = $w_cfg['YaCity'];
		$this->CacheTime = $w_cfg['CacheTime'];
		$this->CachePath = $w_cfg['CachePath'];
	}

	// кэширование файла
	private function CacheFile()
	{
		$modif = time() - @filemtime($this->CachePath);
		if(!file_exists($this->CachePath) || $modif > $this->CacheTime)
		{
			$weather = file_get_contents($this->YaUrl.$this->YaCity);
			$handle = @fopen ($this->CachePath, "w");
			@fwrite($handle, $weather);
			@fclose($handle);
			return(1);
		}
		return(0);
	}

	// парсинг файла
	private function ParseFile()
	{
		// загружаем файл на парсинг
		$weather = simplexml_load_file($this->CachePath);
		// парсим каждый дочерний элемент
		// (0) дата (число, месяц, год)
		// (1) город
		// (2) страна
		// (3) тип погоды
		// (4) картинка в .gif
		// (5) картинка в .png
		// (6) температура
		// (7) давление
		// (8) влажность
		foreach ($weather->children() as $wt)
		{
			$out_arr[] = $wt;
		}
		// обрабатываем картинку в .png
		if (preg_match("/https?:\/\/(?:www.|)[^\s]+\.[a-zA-Z]{2,3}\/i(\/[\S]*)/", $out_arr[5], $url))
		{
			$out_arr[5] = $url[1];
		}
		return($out_arr);
	}

	// вывод файла
	public function OutWeather()
	{
		$this->cacheFile();
		return($this->parsefile());
	}

}